//Solution du dfi Delphi de www.developpez.com :
//
//Un logiciel qui joue tout seul au dmineur
//
//Juin 2006
//Auteur : Waskol

unit UnitMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Grids, UnitSystem, ComCtrls, Gauges, Spin,UnitCommon,
  XPMan;

type
  TFormMain = class(TForm)
    ButtonJouer: TButton;
    Label1: TLabel;
    EditNom: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    RadioGroupNiveau: TRadioGroup;
    RadioGroupTriche: TRadioGroup;
    GBScores: TGroupBox;
    Bevel1: TBevel;
    ButtonReset: TButton;
    ListViewScores: TListView;
    Label4: TLabel;
    Gauge1: TGauge;
    LabelNumPartie: TLabel;
    GBConfiguration: TGroupBox;
    GBAction: TGroupBox;
    Label8: TLabel;
    CBStats: TCheckBox;
    GBJeu: TGroupBox;
    Label7: TLabel;
    SpinEditNbreParties: TSpinEdit;
    Label6: TLabel;
    RadioGroupSouris: TRadioGroup;
    Button1: TButton;
    XPManifest1: TXPManifest;
    procedure ButtonJouerClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ButtonResetClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCanResize(Sender: TObject; var NewWidth,
      NewHeight: Integer; var Resize: Boolean);
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
    procedure DemarrerWinMine;
    procedure UpdateScores;
    procedure ReInitScores;
    procedure InitZoneJeu;
    procedure Jouer;
    procedure ReJouer; //non utilis
    procedure RentreScore;
    procedure ActiveTriche;
    procedure ScreenshotToZoneJeu;
    function EtatduJeu:TEtatDuJeu;
    //    procedure JoueCasesADeminerAutour;
    procedure InventaireCasesAJouer;
//    procedure InventaireCasesADeminerAutour;
    procedure InventaireCasesInconnues;
    procedure InventaireCases;

//3 Moteurs d'analyses :
  //Le "de base"
    procedure RechercheCasesEvidentes;
  //La mthode "Je teste toutes les possibilits" d'une zone
    procedure RechercheSchemas;
    function RechercheSchema(SizeX,SizeY:integer):integer; //retourne le nombre de schemas qui avaient l'air "valables"
  //La mthode qui calcule tout avec renfort de matrices, dnombrement et probabilits
  //(methode de Recherche par satisfaction de contraintes)
    procedure RechercheCSP;

//3 Stratgies de jeu
  //Joue toutes les cases marques "JouerCetteCase:=True" :
    procedure JoueCasesAJouer;
  //Joue les cases qui, statistiquement,
  //sont les moins suceptibles de contenir une mine :
    procedure JoueStatistiques;
  //Joue "au pifomtre"
    procedure JoueAuHasard;
  //Joue En trichant, le vilain ! ("ModeTriche:=True) :)
    procedure JoueTriche;

    function CaseEstDecouverte(u,v:integer):boolean;
    function CaseEstDeminee(u,v:integer):boolean;
    function CaseAExplose(u,v:integer):boolean;

    //voisinage d'une case de la Zone de Jeu
    function CasesAutour(u, v: integer):TSetOfCases;
    function CaseNbreMinesAutour(u,v:integer):integer;
    function CaseNbreCasesAutour(u,v:integer):integer;
    function CaseNbreDemineesAutour(u,v:integer):integer;
    function CaseNbreCasesDecouvertesAutour(u,v:integer):integer;

    //voisinage d'une case incluse dans
    //un schema de recherche (une sous grille de la zone jeu)
    function CaseNbreDemineesAutourSubGrid(i,j,sizex,sizey:integer;SubGrid:TSchema):integer;
    function CaseNbreCasesDecouvertesAutourSubGrid(i,j,sizex,sizey:integer;SubGrid:TSchema): integer;
    function UVToScreen(u,v:integer):TPoint;
    function UVToClient(u,v:integer):TPoint;
    procedure MouseClickOnCase(Boutons:TMouseButtons;u,v:integer);
  public
    { Dclarations publiques }
    //Infos sur le processus
    StartInfo   : TStartupInfo;
    ProcessInfo : TProcessInformation;
    //infos sur la fentre de WinMine
    WinMineHandle:HWND;
    WinMineRect:TRect;
    //Infos sur le jeu
    ModeTriche:boolean;
    ModeSouris:TMouseMode;
    ZoneJeu:array of array of TCase;
    UnEtatDuJeu:TEtatDuJeu;
    CasesInconnues:TSetOfCases;
    JeuStatistique:boolean;
    NBreAJouer,NBreADeminerAutour,NbreInconnues,NbreDeminees,NBreDecouvertes,NbreMinesRestantes,NBreMines:integer;
    UCount,VCount:integer;
    ScreenShot:TBitmap; //avec la couleur des points d'une case
                        //(coordonnes (Haut/Gauche d'un carr de 16 par 16 pixels)
                        // donnes par "XYToClient"
                        // Si le point en haut  gauche est blanc-->undefined
                        // Sinon :
                        //   que du gris dans les cases --> vide
                        //   du Bleu clNavy --> 1
                        //   du vert --> 2
                        //   du rouge --> 3
                        //   ...
                        //   du  noir --> 7
                        //   ...
                        //   du noir ET du blanc --> bombe (on a perdu)
                        //on pourra ainsi connatre l'tat d'une case et mettre  jour notre zone jeu
  end;

var
  FormMain: TFormMain; 

implementation

uses Types,Registry,IniFiles, UnitStats, DateUtils,UnitMineUtils;

{$R *.dfm}

function GetNBreCasesAutour(x,y,GridWidth,GridHeight:integer):integer;
begin
  result:=5;
  if ((x=0) or (x=GridWidth-1)) and ((y=0) or (y=GridHeight-1))
  then result:=3;
  if ((x>0) and (x<GridWidth-1) and (y>0) and (y<GridHeight-1))
  then result:=8;
end;

function GetCasesAutour(x,y,GridWidth,GridHeight:integer):TSetOfCases;
var i,j:Integer;
    UneCase:TPoint;
begin
  SetLength(Result,GetNBreCasesAutour(x,y,GridWidth,GridHeight));
  j:=-1;
  for i:=0 to 7 do
  begin
    UneCase:=CoordsAutour[i];
    UneCase:=Point(UneCase.X+x,UneCase.Y+y);
    if ((UneCase.X>=0) and (UneCase.X<GridWidth)
    and (UneCase.Y>=0) and (UneCase.Y<GridHeight))
    then begin
           Inc(j);
           Result[j]:=UneCase;
         end;
  end;
end;

procedure TFormMain.ButtonJouerClick(Sender: TObject);
var i,Temps:integer;
begin
if RadioGroupSouris.ItemIndex=0
       then ModeSouris:=mmRealClick
       else ModeSouris:=mmVirtualClick;
FormStats.Niveau:=FormMain.ListViewScores.Items[RadioGroupNiveau.ItemIndex].Caption;
Statistiques.AfficheOfficiel:=(CBStats.State=cbChecked);
Statistiques.Initialiser;

NbreDeminees:=0;
NBreDecouvertes:=0;

case RadioGroupNiveau.ItemIndex of
  0:NBreMines:=10;
  1:NBreMines:=40;
  2:NBreMines:=99;
end;

NbreMinesRestantes:=NBreMines-NbreDeminees;

try
  Gauge1.MaxValue:=SpinEditNbreParties.Value;
  Gauge1.Progress:=0;
  if CBStats.State=cbChecked then
  begin
    ReInitScores;
    UpdateScores;
  end;
  for i:=1 to SpinEditNbreParties.Value do
  begin
    LabelNumPartie.Caption:=Format('Partie %d/%d',[i,SpinEditNbreParties.Value]);
    Gauge1.AddProgress(1);
    ButtonJouer.Enabled:=False;
    Label1.Caption:=MessagesStatut[edjEnCours];
    Application.ProcessMessages;
    DemarrerWinMine;
    InitZoneJeu;
    Jouer;
    Label1.Caption:=MessagesStatut[UnEtatDuJeu];
    Application.ProcessMessages;
    Temps:=0;
    if UnEtatDuJeu=edjGagne then
    begin
      RentreScore;
      UpdateScores;
      Application.ProcessMessages;
      Temps:=StrToInt(ListViewScores.Items[RadioGroupNiveau.ItemIndex].SubItems.Strings[1]);
    end;
    Statistiques.AjouteTemps(UnEtatDuJeu,Temps);
    ButtonJouer.Enabled:=True;
  end;
  FormStats.Show;
except
  MessageDlg('Une erreur  t dtecte.'+#13#10#13#10+'vous n''auriez pas fait disparaitre mon dmineur en pleine phase de rflexion par hasard ?', mtError, [mbOK], 0);
  ButtonJouer.Enabled:=True;
end;
end;


procedure TFormMain.DemarrerWinMine;
var i:integer;
begin
  //On cherche si dmineur est dj ouvert
  //(on rcupre son Handle de fentre au passage)
  WinMineHandle:=FindWindow(nil, PChar(WinMineWindowTitle));
  //si oui, on le ferme pour mettre  jour les scores
  if WinMineHandle<>0
  then begin
         FermerApplication(WinMineHandle);
         UpdateScores;
       end;

  ModeTriche:=False;

  { Mise  zro de la structure StartInfo }
  FillChar(StartInfo,SizeOf(StartInfo),#0);
  { Seule la taille est renseigne, toutes les autres options }
  { laisses  zro prendront les valeurs par dfaut }
  StartInfo.cb     := SizeOf(StartInfo);

  { Lancement de la ligne de commande }
  CreateProcess(Nil, '"winmine.exe"', Nil, Nil, False,
                0, Nil, Nil, StartInfo,ProcessInfo);
  //Attend que dmineur soit lanc
  Sleep(1000);
  //on rcupre le Handle sur la fentre du dmineur
  WinMineHandle:=FindWindow(nil, PChar(WinMineWindowTitle));

  //Activation/desactivation du mode triche ???
  if ((RadioGroupTriche.ItemIndex=0) and ModeTriche) then ActiveTriche;
  if ((RadioGroupTriche.ItemIndex=1) and (not ModeTriche)) then ActiveTriche;

  //on active la fentre pour lui envoyer des codes touche
  ActiverFenetre(WinMineHandle);

  //on choisi le niveau = nouvelle partie
    //on ouvre le menu du dmineur
    SimulateKeystroke(VK_MENU,0);
    //on descend dedans jusqu' trouver le niveau souhait
    for i:=1 to RadioGroupNiveau.ItemIndex+2 do
        SimulateKeystroke(VK_DOWN,0);
    //on valide
    SimulateKeystroke(VK_RETURN,0);
    //Attend que dmineur soit prt :
    Sleep(1000);
end;

procedure TFormMain.MouseClickOnCase(Boutons:TMouseButtons;u, v: integer);
begin
  if ModeSouris=mmRealClick
  then begin
         MouseClickOnScreen(Boutons,UVToScreen(u,v));
         Sleep(20); //tempo pour laiss le temps  Windows
                    //de digrer les clics de souris
       end
  else VirtualMouseClickOnWindow(WinMineHandle,Boutons,UVToClient(u,v));
end;

function TFormMain.UVToClient(u, v: integer): TPoint;
begin
  Result.x:=12+16*u+WinMineRect.Left;
  Result.y:=55+16*v+WinMineRect.Top;
end;

function TFormMain.UVToScreen(u, v: integer): TPoint;
var APoint:TPoint;
begin
  APoint.x:=12+8+16*u+WinMineRect.Left;
  APoint.y:=55+8+16*v+WinMineRect.Top;
  Windows.ClientToScreen(WinMineHandle,APoint);
  Result:=APoint;
end;

procedure TFormMain.FormCreate(Sender: TObject);
begin
  ScreenShot:=TBitmap.Create;
  WinMineHandle:=0;
  UpdateScores;
  RadioGroupTriche.Enabled:=(GetWinMineVersion<>v9x);
end;

procedure TFormMain.FormDestroy(Sender: TObject);
begin
  ScreenShot.Free;
end;

procedure TFormMain.InventaireCasesAJouer;
begin
  JeuStatistique:=False;
  NBreAJouer:=0;
  RechercheCasesEvidentes;
  if NBreAJouer=0 then RechercheSchemas;
  if NBreAJouer=0 then RechercheCSP;
end;

procedure TFormMain.InventaireCasesInconnues;
var u,v:integer;
    Inconnues:Boolean;
begin
  for u:=0 to UCount-1 do
    for v:=0 to VCount-1 do
    with ZoneJeu[u,v] do
  begin
    EstDecouverte:=CaseEstDecouverte(u,v);
    EstDeminee:=CaseEstDeminee(u,v);
    AExplose:=CaseAExplose(u,v);
    NbreCasesAutour:=CaseNbreCasesAutour(u,v);
    NbreDemineeAutour:=CaseNbreDemineesAutour(u,v);
    if EstDecouverte
    then NbreMinesAutour:=CaseNbreMinesAutour(u,v)
    else NbreMinesAutour:=-1;
    NbreCasesDecouvertesAutour:=CaseNbreCasesDecouvertesAutour(u,v);
    NbreInconnuesAutour:=NbreCasesAutour-NbreCasesDecouvertesAutour-NbreDemineeAutour;
    if EstDeminee or EstDecouverte then JouerCetteCase:=False;
  end;

  NbreInconnues:=0;
  SetLength(CasesInconnues,NbreInconnues);

  for u:=0 to UCount-1 do
    for v:=0 to VCount-1 do
      Begin
        Inconnues:=not (ZoneJeu[u,v].EstDecouverte or ZoneJeu[u,v].EstDeminee);
        if Inconnues then
        begin
          inc(NbreInconnues);
          SetLength(CasesInconnues,NbreInconnues);
          CasesInconnues[NbreInconnues-1]:=point(u,v);
        end;
      end;
end;

procedure TFormMain.InventaireCases;
var u,v:integer;
begin
  NbreDeminees:=0;
  NBreDecouvertes:=0;
  for u:=0 to UCount-1 do
    for v:=0 to VCount-1 do
    begin
      if ZoneJeu[u,v].EstDeminee then inc(NbreDeminees);
      if ZoneJeu[u,v].EstDecouverte then inc(NBreDecouvertes);
    end;
  NbreMinesRestantes:=NBreMines-NbreDeminees;
end;

procedure TFormMain.ScreenshotToZoneJeu;
type TDirection=(haut,droite,bas,gauche,aucune);
     TSchema=array[0..2,0..2] of TCase;
     TSchemaInconnues=array[0..9] of TCoord;
const Cible:array[haut..gauche] of TPoint=
            ((x:0;y:-1),(x:1;y:0),(x:0;y:1),(x:-1;y:0));
var u,v:integer;
begin
  //Effectue un tat des lieu du plateau de jeu
  for u:=0 to UCount-1 do
    for v:=0 to VCount-1 do
        with ZoneJeu[u,v] do
        begin
          EstDecouverte:=CaseEstDecouverte(u,v);
          EstDeminee:=CaseEstDeminee(u,v);
          AExplose:=CaseAExplose(u,v);
          NbreCasesAutour:=CaseNbreCasesAutour(u,v);
          NbreDemineeAutour:=CaseNbreDemineesAutour(u,v);
          if EstDecouverte
          then NbreMinesAutour:=CaseNbreMinesAutour(u,v)
          else NbreMinesAutour:=-1;
          NbreCasesDecouvertesAutour:=CaseNbreCasesDecouvertesAutour(u,v);
          NbreInconnuesAutour:=NbreCasesAutour-NbreCasesDecouvertesAutour-NbreDemineeAutour;
          //JouerCetteCase:=False;
          OccurencedansSchemas:=0;
          //EvaluationStatistique:=0;
        end;
end;

function TFormMain.CaseAExplose(u, v: integer): boolean;
var APoint:TPoint;
begin
  APoint:=UVToClient(u,v);
  with APoint do
  result:=(CouleurPixel(WinMineHandle,x+7,y+4)=$000000)
           and (CouleurPixel(WinMineHandle,x+6,y+6)=$FFFFFF);
end;

function TFormMain.CaseEstDecouverte(u, v: integer): boolean;
var APoint:TPoint;
    ARGBColor:Cardinal;
begin
  APoint:=UVToClient(u,v);
  with APoint do ARGBColor:=CouleurPixel(WinMineHandle,x,y);
  result:=(ARGBColor=$808080) or (ARGBColor=$848284);
end;

function TFormMain.CaseEstDeminee(u, v: integer): boolean;
var APoint:TPoint;
begin
  APoint:=UVToClient(u,v);
  with APoint do
  result:=(not CaseEstDecouverte(u,v))
           and (CouleurPixel(WinMineHandle,x+7,y+4)=$0000FF);
end;


//voisinage d'une case de la Zone de Jeu
function TFormMain.CasesAutour(u, v: integer):TSetOfCases;
begin
  Result:=GetCasesAutour(u,v,UCount,VCount);
end;

function TFormMain.CaseNbreCasesAutour(u, v: integer): integer;
begin
  result:=GetNBreCasesAutour(u,v,UCount,VCount);
end;

function TFormMain.CaseNbreCasesDecouvertesAutour(u, v: integer): integer;
var i,n:integer;
    ASet:TSetOfCases;
    ACoord:TPoint;
begin
  ASet:=CasesAutour(u,v);
  n:=0;
  for i:=Low(ASet) to High(ASet) do
  begin
    ACoord:=ASet[i];
    if CaseEstDecouverte(ACoord.X,ACoord.Y) then inc(n);
  end;
  Result:=n;
end;

function TFormMain.CaseNbreDemineesAutour(u, v: integer): integer;
var i,n:Integer;
    ASet:TSetOfCases;
    ACoord:TPoint;
begin
  ASet:=CasesAutour(u,v);
  n:=0;
  for i:=Low(ASet) to High(ASet) do
  begin
    ACoord:=Aset[i];
    if CaseEstDeminee(ACoord.X,ACoord.Y) then inc(n);
  end;
  Result:=n;
end;

function TFormMain.CaseNbreMinesAutour(u, v: integer): integer;
var APoint:TPoint;
    RGB_Color:Cardinal;
begin
  APoint:=UVToClient(u,v);
  with APoint do
  RGB_Color:=CouleurPixel(WinMineHandle,x+7,y+4);
  Result:=0;
  case RGB_Color of
     $FF0000:result:=1;
     $008000,$008200:result:=2;
     $0000FF:result:=3;
     $800000,$840000:result:=4;
     $000080,$000084:result:=5;
     $808000,$848200:result:=6;
     $000000:result:=7;
     $808080,$848284:result:=8;
  end;
end;

//Obtenir le Nbre de case dcouvertes autour d'une case incluse dans
//un schema de recherche (une sous grille de la zone jeu)
function TFormMain.CaseNbreDemineesAutourSubGrid(i,j,sizex,sizey:integer;SubGrid:TSchema):integer;
var k:integer;
    ASet:TSetOfCases;
begin
  ASet:=GetCasesAutour(i,j,sizex,sizey);
  Result:=0;
  for k:=Low(ASet) to High(ASet) do
    with ASet[k] do if SubGrid[X,Y].EstDeminee then Inc(Result);
end;

function TFormMain.CaseNbreCasesDecouvertesAutourSubGrid(i,j,sizex,sizey:integer;SubGrid:TSchema): integer;
var k:integer;
    ASet:TSetOfCases;
begin
  ASet:=GetCasesAutour(i,j,sizex,sizey);
  Result:=0;
  for k:=Low(ASet) to High(ASet) do
  begin
    with ASet[k] do if SubGrid[X,Y].EstDecouverte then Inc(Result);
  end;
end;

function TFormMain.EtatduJeu: TEtatDuJeu;
var x:integer;
    etat:smallint;
    Pixel1,Pixel2:Cardinal;
begin
  etat:=0;
  Application.ProcessMessages;

  //on teste le smiley :)
  x:=(WinMineRect.Right div 2)+2;

  //on va tester ses lunettes 8)
  Pixel1:=CouleurPixel(WinMineHandle,x,25);

  //et son sourire (ou plutt s'il fait la tte :( )
  Pixel2:=CouleurPixel(WinMineHandle,x,30);
  with ScreenShot.Canvas do
  begin

    if (Pixel1=$000000)
    then etat:=etat or 1
    else if (Pixel1<>$00FFFF)
         then etat:=etat+4;

    if (Pixel2=$000000)
    then etat:=etat or 2
    else if (Pixel2<>$00FFFF)
         then etat:=etat+4;
  end;
  //resultat du test
  case etat of
    0:Result:=edjEnCours;
    1:Result:=edjGagne;
    2:Result:=edjPerdu;
  else
    Result:=edjErreur;  //securit
  end;
  if etat<>0 then Statistiques.StopChrono;
end;

procedure TFormMain.JoueAuHasard;
var CaseAuHasard,i,j:integer;
    CaseTrouvee:boolean; //en mode triche
    APoint,T:TPoint;
    ABitmap:TBitmap;
    PixelColor:TColor;
begin
  if not JeuStatistique then ScreenshotToZoneJeu;
  InventaireCases;
  InventaireCasesInconnues;
  if JeuStatistique then //trier les cases inconnues par ordre statistique
                         //(tri par selection, par ordre dcroissant)
  begin
    for I :=0 to NbreInconnues - 2 do
        for J := NbreInconnues-1 downto I + 1 do
          if ZoneJeu[CasesInconnues[I].X,CasesInconnues[I].Y].EvaluationStatistique>ZoneJeu[CasesInconnues[J].X,CasesInconnues[J].Y].EvaluationStatistique then
          begin
            T := CasesInconnues[I];
            CasesInconnues[I] := CasesInconnues[J];
            CasesInconnues[J] := T;
          end;
  end;
  if NbreInconnues>0 then
  begin
    if not ModeTriche
    then begin
            if JeuStatistique
            then CaseAuHasard:=0
            else CaseAuHasard:=Trunc(Random(NbreInconnues));
         end
    else
    begin
      CaseAuHasard:=0; //Au hazard, en mode triche, bien sur, bien sur... :)
      CaseTrouvee:=false;
      Abitmap:= TBitmap.Create; // Cration d'une image bitmap
      try
      while ((CaseAuHasard<NbreInconnues) and (not CaseTrouvee)) do
      begin
        with CasesInconnues[CaseAuHasard] do Apoint:=UVToScreen(X,Y);
        //on place la souris au dessus de la case  tester
        SetCursorPos(APoint.X,APoint.y);
        sleep(100);
        ScreenShotDesktop(ABitmap,Screen);
        //Si le point,en haut  gauche sur l'cran est blanc, on considre que c'est bon
        PixelColor:=ABitmap.Canvas.Pixels[0,0];
        CaseTrouvee:=(PixelColor<>clBlack);
        if (not CaseTrouvee) then inc(CaseAuHasard);
      end;
      finally
        ABitmap.Free;
      end;
    end;
    with CasesInconnues[CaseAuHasard] do
      MouseClickOnCase(BoutonGauche,X,Y);
  end;
  JeuStatistique:=False;
end;

procedure TFormMain.JoueCasesAJouer;
var u,v:integer;
begin
  for u:=0 to UCount-1 do
    for v:=0 to VCount-1 do
      With ZoneJeu[u,v] do
        if JouerCetteCase then
        begin
          MouseClickOnCase(Methode,u,v);
          JouerCetteCase:=False;
        end;
  NBreAJouer:=0;
end;

procedure TFormMain.JoueStatistiques;
var i,j:integer;
    T:TPoint;
begin
//  ScreenshotToZoneJeu;
//  InventaireCases;
  InventaireCasesInconnues; //Rsultat renvoy dans le tableau CasesInconnues[I]

  //trier les cases inconnues par ordre statistique
  //(tri "par selection", par ordre dcroissant)
  for I :=0 to NbreInconnues - 2 do
    for J := NbreInconnues-1 downto I + 1 do
      if ZoneJeu[CasesInconnues[I].X,CasesInconnues[I].Y].EvaluationStatistique>ZoneJeu[CasesInconnues[J].X,CasesInconnues[J].Y].EvaluationStatistique then
      begin
        T := CasesInconnues[I];
        CasesInconnues[I] := CasesInconnues[J];
        CasesInconnues[J] := T;
      end;

  if NbreInconnues>0 then //Il y en a forcment !
  begin
    with CasesInconnues[0] do
      MouseClickOnCase(BoutonGauche,X,Y);
  end;
  JeuStatistique:=False;
end;

procedure TFormMain.JoueTriche;
var APoint:TPoint;
    ABitmap:TBitmap;
    PixelColor:TColor;
    u,v:integer;
begin
  ScreenshotToZoneJeu;
  InventaireCases;
  InventaireCasesInconnues;

  NBreAJouer:=0;
  if NbreInconnues>0 then
  begin
    Abitmap:= TBitmap.Create; // Cration d'une image bitmap
    try
    for u:=0 to UCount-1 do
    for v:=0 to VCount-1 do
    with ZoneJeu[u,v] do
    begin
      JouerCetteCase:=False;
      if not EstDecouverte then
      begin
        Apoint:=UVToScreen(u,v);
        //on place la souris au dessus de la case  tester
        SetCursorPos(APoint.X+2,APoint.Y+2);
        sleep(10);
        ScreenShotDesktop(ABitmap,Screen);
        sleep(10);
        //Si le point,en haut  gauche sur l'cran est blanc, on considre que c'est bon
        PixelColor:=ABitmap.Canvas.Pixels[0,0];
        if (PixelColor<>clBlack)
        then begin
               JouerCetteCase:=True;
               Methode:=BoutonGauche;
               inc(NBreAJouer)
             end;
      end;
    end;
    finally
      ABitmap.Free;
    end;
  end;
  JeuStatistique:=False;
end;

procedure TFormMain.Jouer;
var PremierCoup:boolean;
begin
  JeuStatistique:=false;
  PremierCoup:=true;
  ScreenshotToZoneJeu;
  UnEtatDuJeu:=edjEnCours;
  while UnEtatDuJeu=edjEnCours do
  begin
    if PremierCoup //Le premier coup, on joue au hasard
    then begin
           Statistiques.StartChrono;
           JoueAuHasard;
           PremierCoup:=False;
         end
    else begin
           if ModeTriche
           then begin
                  JoueTriche;
                  JoueCasesAJouer;
                end
           else begin //l c'est du srieux
                  ScreenshotToZoneJeu;
                  InventaireCases;
                  InventaireCasesAJouer;
                  if JeuStatistique
                  then JoueStatistiques
                  else if NBreAJouer>0
                       then JoueCasesAJouer
                       else JoueAuHasard;
                 end;
         end;
    ScreenshotToZoneJeu;
    InventaireCases;
    UnEtatDuJeu:=EtatduJeu;
  end;
end;

procedure TFormMain.InitZoneJeu;
begin
  //La zone cliente du dmineur
  Windows.GetClientRect(WinMineHandle,WinMineRect);
  //Windows.GetClipBox()
  //Le terrain de jeu (le cerveau de notre programme)
  uCount:=(WinMineRect.Right-WinMineRect.Left-20) div 16;
  vCount:=(WinMineRect.Bottom-WinMineRect.top-63) div 16;
  SetLength(ZoneJeu,uCount,vCount);
end;

procedure TFormMain.RentreScore;
begin
  SendKeys(EditNom.Text);
  SimulateKeystroke(VK_RETURN, 0);
  if SpinEditNbreParties.Value<=10 then
  begin
    Label1.Caption:='Admirez le score 3 secondes... Merci ;p';
    label1.Font.Color:=clRed;
    Application.ProcessMessages;
    Sleep(3000);
  end;
  sleep(100);
  Label1.Caption:=MessagesStatut[UnEtatDuJeu];
  label1.Font.Color:=clWindowText;
  SimulateKeystroke(VK_RETURN, 0)
end;

procedure TFormMain.ReJouer;
var x:integer;
    APoint:TPoint;
begin
  //On clique sur le smiley ;)

  ScreenshotToZoneJeu;
  Application.ProcessMessages;
  //on teste le smiley :)
  x:=(ScreenShot.Width div 2)+2;
  APoint.x:=WinMineRect.Left+x;
  APoint.y:=WinMineRect.Top+25;
  Windows.ClientToScreen(WinMineHandle,APoint);
  MouseClickOnScreen(BoutonGauche,APoint);
end;


//Reset des scores
procedure TFormMain.ReInitScores;
var Chemin:string;
begin
   FermerApplication(WinMineHandle);
   Chemin:=IncludeTrailingBackslash(WindowsDirectory);
   case GetWinMineVersion of
     v9x:Chemin:=Chemin+'WINMINE.INI';
     vNT:Chemin:=Chemin+'ENTPACK.INI';
   end;

   case GetWinMineVersion of
     v9x,vNT:with TIniFile.Create(Chemin) do
         try
           with ListViewScores.Items do
             begin
               WriteString('Dmineur','Name1','Anonyme');
               WriteString('Dmineur','Name2','Anonyme');
               WriteString('Dmineur','Name3','Anonyme');
               WriteInteger('Dmineur','Time1',999);
               WriteInteger('Dmineur','Time2',999);
               WriteInteger('Dmineur','Time3',999);
             end;
         finally
           Free;
         end;
     vXP:begin
           with TRegistry.Create do
           try
             RootKey:=HKEY_CURRENT_USER;
             OpenKey('\Software\Microsoft\Winmine',True);
             WriteString('Name1','Anonyme');
             WriteString('Name2','Anonyme');
             WriteString('Name3','Anonyme');
             WriteInteger('Time1',999);
             WriteInteger('Time2',999);
             WriteInteger('Time3',999);
           finally
             Free;
           end;
         end;
  end;
end;

//mise  jour des scores
procedure TFormMain.UpdateScores;
var Chemin:string;
begin
   FermerApplication(WinMineHandle);
   sleep(10);
   Chemin:=IncludeTrailingBackslash(WindowsDirectory);
   case GetWinMineVersion of
     v9x:Chemin:=Chemin+'WINMINE.INI';
     vNT:Chemin:=Chemin+'ENTPACK.INI';
   end;

   case GetWinMineVersion of
     v9x,vNT:with TIniFile.Create(Chemin) do
         try
           with ListViewScores.Items do
             begin
               Item[0].SubItems.Strings[0]:=ReadString('Dmineur','Name1','-');
               Item[1].SubItems.Strings[0]:=ReadString('Dmineur','Name2','-');
               Item[2].SubItems.Strings[0]:=ReadString('Dmineur','Name3','-');
               Item[0].SubItems.Strings[1]:=IntToStr(ReadInteger('Dmineur','Time1',999));
               Item[1].SubItems.Strings[1]:=IntToStr(ReadInteger('Dmineur','Time2',999));
               Item[2].SubItems.Strings[1]:=IntToStr(ReadInteger('Dmineur','Time3',999));
             end;
         finally
           Free;
         end;
     vXP:begin
           with TRegistry.Create do
           try
             RootKey:=HKEY_CURRENT_USER;
             OpenKey('\Software\Microsoft\Winmine', True);
             with ListViewScores.Items do
             begin
               Item[0].SubItems.Strings[0]:=ReadString('Name1');
               Item[1].SubItems.Strings[0]:=ReadString('Name2');
               Item[2].SubItems.Strings[0]:=ReadString('Name3');
               Item[0].SubItems.Strings[1]:=IntToStr(ReadInteger('Time1'));
               Item[1].SubItems.Strings[1]:=IntToStr(ReadInteger('Time2'));
               Item[2].SubItems.Strings[1]:=IntToStr(ReadInteger('Time3'));
             end;
           finally
             Free;
           end;
         end;
   end;
end;

procedure TFormMain.ButtonResetClick(Sender: TObject);
begin
  FermerApplication(WinMineHandle);
  ReInitScores;
  UpdateScores;
end;

procedure TFormMain.ActiveTriche;
begin
  ModeTriche:=not ModeTriche;
  ActiverFenetre(WinMineHandle);
  SendKeys('xyzzy');
  SimulateKeystroke(VK_RETURN,0);
  SimulateKeystroke(VK_SHIFT,0);
end;

procedure TFormMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  WinMineHandle:=FindWindow(nil, PChar(WinMineWindowTitle));
  //si oui, on le ferme pour mettre  jour les scores
  if WinMineHandle<>0
  then FermerApplication(WinMineHandle);
end;

procedure TFormMain.FormCanResize(Sender: TObject; var NewWidth,
  NewHeight: Integer; var Resize: Boolean);
begin
  resize:=False;
end;

procedure TFormMain.Button1Click(Sender: TObject);
begin
  FormStats.Show;
end;

procedure TFormMain.RechercheCasesEvidentes;
var u,v:integer;
    DecouvrirAutour,DeminerAutour:boolean;
    ASet:TSetOfCases;
    i:integer;
begin
  for u:=0 to UCount-1 do
    for v:=0 to VCount-1 do
      Begin
        with ZoneJeu[u,v] do
        begin
          OccurencedansSchemas:=0;
          EvaluationStatistique:=0;
          if EstDecouverte then
          begin
            DecouvrirAutour:=(NbreMinesAutour=NbreDemineeAutour) and (NbreMinesAutour<>0) and (NbreCasesAutour-NbreCasesDecouvertesAutour-NbreDemineeAutour>0);
            if DecouvrirAutour then begin
                                      JouerCetteCase:=True;
                                      Methode:=LesDeuxBoutons;
                                      Inc(NBreAJouer);
                                    end;
            DeminerAutour:=(NbreInconnuesAutour>0);
            DeminerAutour:=DeminerAutour and ((NbreInconnuesAutour+NbreDemineeAutour)=NbreMinesAutour);
            //(NbreCasesAutour=(NbreMinesAutour+NbreCasesDecouvertesAutour)) and (NbreMinesAutour>NbreDemineeAutour);
            if DeminerAutour then
            begin
              ASet:=CasesAutour(u,v);
              for i:=Low(Aset) to High(ASet) do
                with Aset[i] do with ZoneJeu[X,Y] do
                begin
                  if ((not EstDecouverte) and (Not EstDeminee)) then
                  begin
                    JouerCetteCase:=true;
                    Methode:=BoutonDroit;
                    Inc(NBreAJouer);
                  end;
                end;
            end;
          end;
        end;
      end;
end;


procedure TFormMain.RechercheSchemas;
var TailleSchema:integer;
    NBreSchemasExploitables:Integer;
begin
  //Choix compltement arbitraire pour entrer dans la boucle qui suit
  NBreSchemasExploitables:=10;
  TailleSchema:=3;
  InventaireCases;
  while ((NBreAJouer<=0) and (NBreSchemasExploitables>TailleSchema)
         and (TailleSchema<7) and (TailleSchema*TailleSchema-NBreDecouvertes<32)) do
  begin
    NBreAJouer:=0;
    NBreSchemasExploitables:=RechercheSchema(TailleSchema,TailleSchema);
    Inc(TailleSchema);
  end;
end;

function TFormMain.RechercheSchema(SizeX,SizeY:integer):integer;
var u,v,i,j,k,uu,vv,NbredeTests:integer;
    SchemaRef,SchemaTest:TSchema;
    Inconnues:TSetOfCases;
    NbrInconnuesATester:Integer;
    NbreDecouvertesSchema:integer;
    TestEnCours:Cardinal;
    ResultatADeminer:Cardinal;
    ResultatAJouer:Cardinal;
    SchemaEstValide,SchemaValideTrouve:boolean;
    //SchemaAJouerEstValide,SchemaAJouerValideTrouve:boolean;
    NBreSchemaValides:integer;
    ASet:TSetOfCases;
    NBredeMinesSupposeesAutour:integer;
    ACoord:TPoint;
    sch:array[0..2,0..2] of string;
    NbreVariantes:integer;
    OccurencesSchemaNonTestees,OccurencesTotalesNonTestees,
    NbreMinesRestantesDansInconnuesNonTestees,NBreInconnuesNonTestees:integer;

begin
//cette fonction recherche des shmas de gains
//et retourne le nombre de schema exploitables qu'elle  trouv :
//
//En fait, elle effectue une recherche systmatique sur toute ou partie
//du champ de mines (ZoneJeu) qu'elle duplique dans un "Schma de Test"
//Toutes les combinaisons "il y a une mine/pas de mine" sont envisages en
//exploitant l'utilisation des bits d'un entier 32bits o chaque bit
//reprsente l'une des cases encore inconnue du schma.
//il suffit alors d'incrmenter cet entier, puis de confronter la combinaison
//aux indications donnes p r les cases contenant un chiffre pour dterminer si
//on a ainsi cr un schma valide.
//De l, si le shma est valide, on utilise un "masque de bits" sur deux
//autres entiers (ResultatADeminer et ResultatAJouer).
//Aprs avoir test toutes les combinaisons on exploite la valeur des bits
//restants dans ces deux entiers pour tablir la stratgie de Jeu 
//on est donc limit  32 cases inconnues :/
Result:=0;
//parcours de la zone de Jeu
SetLength(SchemaRef,sizex,sizey);
SetLength(SchemaTest,sizex,sizey);
u:=0;
while ((u<UCount-sizex) and (NBreAJouer=0)) do
begin
  v:=0;
  while ((v<VCount-sizey) and (NBreAJouer=0)) do
  begin
     //Construction de la grille de rfrence
     NbrInconnuesATester:=0;
     NbreDecouvertesSchema:=0;
     for i:=0 to sizex-1 do
        for j:=0 to sizey-1 do
        begin
           SchemaRef[i,j]:=ZoneJeu[u+i,v+j];
           //si on a une case inconnue
           if ((not SchemaRef[i,j].EstDecouverte)
           and (not SchemaRef[i,j].EstDeminee)
           and (SchemaRef[i,j].NbreCasesDecouvertesAutour>0))
           then begin
                  //on en fait l'inventaire
                  Inc(NbrInconnuesATester);
                  SetLength(Inconnues,NbrInconnuesATester);
                  Inconnues[NbrInconnuesATester-1].x:=i;
                  Inconnues[NbrInconnuesATester-1].y:=j;
                end;
           if SchemaRef[i,j].EstDecouverte then Inc(NbreDecouvertesSchema);
        end;
//           Inutile de s'attarder sur ces schemas...
     if ((NbrInconnuesATester=0) //...o tout est rsolu
      or (NbreDecouvertesSchema<3) //...o trop peu est connu
      or (NbrInconnuesATester>32)) //et l, il y a trop d'inconnues (on travaille sur 32bits !)
     then begin
            Inc(v);
            Continue;
          end;
     //On a trouv un schma exploitable
     Inc(Result);
     NBreInconnuesNonTestees:=NbreInconnues-NbrInconnuesATester;
     OccurencesTotalesNonTestees:=0;
     
     //initialisation des masques de rsultat
     ResultatADeminer:=$FFFFFFFF;
     ResultatAJouer:=$FFFFFFFF;
     SchemaValideTrouve:=false;
     //SchemaAJouerValideTrouve:=false;
     NBreSchemaValides:=0;
     //1 bit de test par cases Non dcouverte
     //correspond  2^NbreInconnues tests
     NbredeTests:=(1 shl NbrInconnuesATester);

     //Determines les Cases dcouvertes  Tester
     for i:=0 to sizex-1 do
        for j:=0 to sizey-1 do
          with SchemaRef[i,j] do
            begin
              NbreInconnuesAutourDansSchema:=GetNBreCasesAutour(i,j,sizex,sizey)
                                            -CaseNbreCasesDecouvertesAutourSubGrid(i,j,Sizex,SizeY,SchemaRef)
                                            -CaseNbreDemineesAutourSubGrid(i,j,Sizex,SizeY,SchemaRef);
              ATesterDansSchema:=EstDecouverte and (NbreMinesAutour>0) and (NbreInconnuesAutourDansSchema>0);
              if ATesterDansSchema then
              begin
                NbreMinesPotentiellesAutour:=NbreInconnuesAutour-NbreInconnuesAutourDansSchema;
                if NbreMinesAutour<NbreMinesPotentiellesAutour then NbreMinesPotentiellesAutour:=NbreMinesAutour;
              end;
            end;

     for TestEnCours:=0 to NbredeTests-1 do
     begin
       //On met en place un schma de test
       for i:=0 to sizex-1 do
        for j:=0 to sizey-1 do
            SchemaTest[i,j]:=SchemaRef[i,j];
       for i:=0 to NbrInconnuesATester-1 do
       begin
         with Inconnues[i] do with SchemaTest[x,y] do
         begin
           EstDeminee:=TestBit(TestEnCours,i);
           EstDecouverte:=not EstDeminee;
         end;
       end;
       //on teste la validit du schma de Test
       SchemaEstValide:=true and (NumBitsOn(TestEnCours,NbrInconnuesATester-1)<=NbreMinesRestantes);
//       if NbrInconnuesATester>NbreMinesRestantes then
//       SchemaEstValide:=true and (NumBitsOn(TestEnCours,NbrInconnuesATester-1)=NbreMinesRestantes);
       i:=0;
       while ((i<sizex) and SchemaEstValide) do
       begin
         j:=0;
         while ((j<sizey) and SchemaEstValide) do
         begin
           NBredeMinesSupposeesAutour:=0;
           //si on a une case dcouverte sur le schma de rfrence
           //and (NbreInconnuesAutour=NbreInconnuesAutourDansSchema);
           if SchemaRef[i,j].ATesterDansSchema
           then begin
                  ASet:=GetCasesAutour(i,j,sizex,sizey);
                  for k:=Low(ASet) to High(ASet) do
                    with ASet[k] do
                       if SchemaTest[X,Y].EstDeminee and (not ZoneJeu[u+x,v+y].EstDeminee)
                       then Inc(NBredeMinesSupposeesAutour);
                  with SchemaRef[i,j] do
                  begin
                    if (NBredeMinesSupposeesAutour>NbreMinesAutour)
                    then SchemaEstValide:=false;
                    if (NbreMinesPotentiellesAutour=0) then
                    if (NBredeMinesSupposeesAutour+NbreDemineeAutour)<>NbreMinesAutour
                    then SchemaEstValide:=false;
                    if (NbreMinesPotentiellesAutour>0) then
                    if (NBredeMinesSupposeesAutour+NbreMinesPotentiellesAutour+NbreDemineeAutour)<NbreMinesAutour
                    then SchemaEstValide:=false;
                  end;
                end;
           Inc(j);
         end;
         Inc(i);
       end;

       //si le test est valide
       if SchemaEstValide then
       begin
         ResultatADeminer:=ResultatADeminer and TestEnCours;
         ResultatAJouer:=ResultatAJouer and not TestEnCours;
         SchemaValideTrouve:=true;
         NbreVariantes:=1;
         //if JeuStatistique
//         then begin
//                NbreMinesRestantesDansInconnuesNonTestees:=NbreMinesRestantes-NumBitsOn(TestEnCours,NbrInconnuesATester-1);
//                OccurencesSchemaNonTestees:=1;
//                NbreVariantes:=Comb(NBreInconnuesNonTestees,NbreMinesRestantesDansInconnuesNonTestees);
//                OccurencesSchemaNonTestees:=Occurences(NBreInconnuesNonTestees,NbreMinesRestantesDansInconnuesNonTestees);
//               end;

         inc(NBreSchemaValides,NbreVariantes);
         //if JeuStatistique
//         then begin
//                 inc(OccurencesTotalesNonTestees,OccurencesSchemaNonTestees);
//                 for i:=0 to NbrInconnuesATester-1 do
//                  begin
//                     if TestBit(TestEnCours,i) then
//                       with Inconnues[i] do with ZoneJeu[u+X,v+Y] do
//                           inc(OccurencedansSchemas,NbreVariantes);
//                  end;
//               end;
       end;
     end;

    //Mise  jour de ce qui doit tre jou
//    if JeuStatistique then
    if NBreSchemaValides>0 then
    begin
      for i:=0 to NbrInconnuesATester-1 do
      begin
         with Inconnues[i] do with ZoneJeu[u+X,v+Y] do
         begin
           JouerCetteCase:=false;
           Methode:=BoutonGauche;
           if JeuStatistique then EvaluationStatistique:=OccurencedansSchemas/NBreSchemaValides;
         end;
         if TestBit(ResultatADeminer,i) then
         begin
           inc(NBreAJouer);
           with Inconnues[i] do with ZoneJeu[u+X,v+Y] do
           begin
             JouerCetteCase:=True;
             Methode:=BoutonDroit;
             EvaluationStatistique:=1;
             Inc(NBreAJouer);
           end;
         end;
         if TestBit(ResultatAJouer,i) then
         begin
           inc(NBreAJouer);
           with Inconnues[i] do with ZoneJeu[u+X,v+Y] do
           begin
             JouerCetteCase:=True;
             Methode:=BoutonGauche;
             EvaluationStatistique:=0;
             Inc(NBreAJouer);
           end;
         end;
      end;
      if JeuStatistique then
      for i:=0 to UCount-1 do
        for j:=0 to VCount-1 do
          with ZoneJeu[i,j] do
              if EvaluationStatistique=0 then
                 EvaluationStatistique:=OccurencesTotalesNonTestees/NBreSchemaValides;
    end;
    Inc(v);
  end;
  Inc(u);
end;
end;

procedure TFormMain.RechercheCSP;
var Contraintes:TMatrice;
    NbreNonDevinables:integer;
    MappageCases:TMatrice;
    i,j,k,EqNum,u,v,NbredeValeurs:integer;
    ASet:TSetOfCases;
    Probas:TTableauReel;
begin
  SetLength(Contraintes,0,0);
  SetLength(Probas,0);
  SetLength(MappageCases,0,0);
  //Etape 1 : Mapping des case
  //Pour Chaque case,
  //SI    (elle est dcouverte ET est situe  ct d'une case inconnue)
  //ALORS elle reoit le chiffre -1 (c'est une case "Non devinable")

  //SI    (elle c'est une case inconnue ET est situe  ct d'une case dcouverte)
  //ALORS on lui attribue une valeur de 1  n-1 et reprsenteront une inconnue xi
  //      Ainsi, l'ensemble des cases seront indices pour reprsenter
  //      une inconnue Xi (i allant de 1  NbredeValeurs-1)

  //Les cases "non devinables" recevant la chiffre 0,
  //    seront regrouppes dans une super-variable X0

  //Les cases qui n'entrent pas en jeu dans l'valuation prennent la valeur -2
  NbredeValeurs:=1;
  NbreNonDevinables:=0;
  SetLength(MappageCases,UCount,VCount);
  for u:=0 to UCount-1 do
    for v:=0 to VCount-1 do
      Begin
        with ZoneJeu[u,v] do
           if (NbreCasesDecouvertesAutour=0) and (not EstDecouverte)
           then begin
                  MappageCases[u,v]:=0;
                  Inc(NbreNonDevinables);
                end
           else begin
                  if ((not EstDecouverte) and (NbreCasesDecouvertesAutour>0) and (not EstDeminee)) then
                  begin
                    //C'est une valeur  dcouvrir
                    MappageCases[u,v]:=NbredeValeurs;
                    Inc(NbredeValeurs);
                  end
                  else if (EstDecouverte and  (NbreInconnuesAutour>0) and (not EstDeminee))
                       then MappageCases[u,v]:=-2  //C'est une contrainte
                       else MappageCases[u,v]:=-1;
                end;
      end;

  //Etape 2 : Construction du tableau de contraintes
  //          (c'est--dire un systme d'quations linaires  N inconnues :
  //          (on va donc rentrer les coefficients dans une matrice (n+1)xn o
  //           la dernire colonne est le nombre  droite de l'galit (=nombre de mines))
  //           les indices de lignes et colonnes partant de zro,
  //           la dernire colonne est la numro n, la dernire ligne est la N (n-1)
  //
  //1) Pour chaque case dj dcouverte, on a une contrainte :
  //   a) Soit la case est une mine on a une quation simplissime : Xi=1
  //      (i est la valeur que l'on a donn  notre case lors du "mappage")
  //   b) si la case est entoure de certaines mines encore inconnues
  //      ET contient un chiffre (donc n'est pas une mine) alors on a comme
  //      quation : Somme(des Xi des cases autour)=valeur de notre case
  //2) Puis une contrainte supplmentaire o Somme(de tout les Xi)=NbreDeMines
  //   (Equation reprsente par la Ligne numro zro)

  SetLength(Contraintes,NbredeValeurs+1,NbredeValeurs);
  SetLength(Probas,NbredeValeurs);
  for i:=0 to NbredeValeurs do
     for j:=0 to NbredeValeurs-1 do
        Contraintes[i,j]:=0;
  //On commence par la contrainte Somme(de tout les Xi)=NbreDeMines
  //j:=0;
  for i:=0 to NbredeValeurs-1 do Contraintes[i,0]:=1;
  Contraintes[NbredeValeurs,0]:=NbreMinesRestantes; //Nombres de mines restantes dans
                                           //toute notre zone de jeu
  EqNum:=1;
  // construction de chaque contrainte
  for u:=0 to UCount-1 do
    for v:=0 to VCount-1 do
        if MappageCases[u,v]=-2
        then begin
               if ZoneJeu[u,v].EstDecouverte
               then begin
                       Inc(EqNum);
                       if EqNum>NbredeValeurs-1 then SetLength(Contraintes,NbredeValeurs+1,EqNum+1);
                       //Obtention des coordonnes de toutes les cases autour
                       //de la case de coordonnes (u,v)
                       ASet:=GetCasesAutour(u,v,UCount,VCount);
                       //Pour chacune de ces cases
                       for k:=Low(ASet) to High(ASet) do
                           with ASet[k] do
                                //si c'est une case inconnue (non dcouverte) ou dmine
                                if (MappageCases[X,Y]>0)
                                then begin
                                       i:=MappageCases[X,Y];
                                       Contraintes[i,EqNum]:=1;
                                     end;
                      Contraintes[NbredeValeurs,EqNum]:=ZoneJeu[u,v].NbreMinesAutour-ZoneJeu[u,v].NbreDemineeAutour;

                    end;
             end;

  //On a notre systme au complet, on lance la rsolution de notre problme
  //dit "CSP" (Constraint Satisfaction Problem --> Problme de satisfaction de contraintes)
  CSPMine(Contraintes,Probas,NbreNonDevinables);

  //On interprte notre rsultat qui se trouve dans Probas
  //Probas(i) reprsente la probabilit un rel (de 0  1) d'avoir une mine pour la mine associe  Xi
  NBreAJouer:=0;
  for u:=0 to UCount-1 do
    for v:=0 to VCount-1 do
    begin
      with ZoneJeu[u,v] do
      begin
        JouerCetteCase:=False;
        Methode:=BoutonGauche;
        k:=MappageCases[u,v];
        if k>=0 then
        begin
          EvaluationStatistique:=Probas[k];
          if EvaluationStatistique>0.999 then EvaluationStatistique:=1;
          if EvaluationStatistique<0.001 then EvaluationStatistique:=0;
          //si c'est une case inconnue
          if not EstDecouverte then
          begin
            //Si on a 0% de chances d'avoir une mine, c'est un coup sur,
            //donc un coup " jouer"
            if EvaluationStatistique=0
            then begin //Il n'y a pas de mine
                   JouerCetteCase:=True;
                   Methode:=BoutonGauche;
                   Inc(NBreAJouer);
                 end;
            //Si on a 100% de chances d'avoir une mine,
            //c'est aussi un coup sur (avec le clic-droit)
            //donc aussi un coup " jouer"
            if EvaluationStatistique=1
            then begin
                   JouerCetteCase:=True;
                   Methode:=BoutonDroit;
                   Inc(NBreAJouer);
                 end;
          end;       
        end;
      end;
    end;
    JeuStatistique:=(NBreAJouer=0);
    SetLength(Probas,0);
end;





end.
