unit UnitSystem;
//routines "systme" diverses
interface
uses Forms,Windows,Graphics;
type
  TMouseButtons=(BoutonGauche,BoutonDroit,LesDeuxBoutons);
  TWinVer=(Win_NT_351,Win_95,Win_NT_40,Win_98,Win_ME,Win_2000,Win_XP,Win_Server_2003,Win_XXX);

const TWinverString:array[Win_NT_351..Win_XXX] of string=
         ('Microsoft Windows NT 3.51','Microsoft Windows 95',
          'Microsoft Windows NT 4.0','Microsoft Windows 98',
          'Microsoft Windows Millennium Edition','Microsoft Windows 2000',
          'Microsoft Windows XP','Microsoft Windows Server 2003',
          'Inconnue');

//pour obtenir la version de windows
function WindowsVersion: TWinVer;

//pour obtenir le rpertoire de windows
function WindowsDirectory: String;

//Simulation du clic sur l'cran : cliques rellement (dplace la souris)
procedure MouseClickOnScreen(Boutons:TMouseButtons;APoint: TPoint);
//Simulation du clic sur l'cran : clic virtuel (ne dplace pas la souris)
procedure VirtualMouseClickOnWindow(AWindowHandle:HWND;Boutons:TMouseButtons;APoint: TPoint);

//Boutons de souris inverss ??
function LeftHandledMouseConfig:Boolean;

//Activation d'une fentre (clic sur sa barre de titre)
procedure ActiverFenetre(AHandle:HWND);

//Fermeture d'une application
procedure FermerApplication(AHandle:HWND);

//Simulation d'appui de touches (fonctionnent sur une fentre active)
procedure SimulateKeyDown(Key : byte);
procedure SimulateKeyUp(Key : byte);
procedure SimulateKeystroke(Key : byte; extra : DWORD);
procedure SendKeys(s : string);

//Copier la zone cliente d'une fentre dans un bitmap (screenshot de la zone cliente)
procedure CopyClientRectToBitmap(WindowHandle:HWND;ABitmap:TBitmap);

//Copier l'image d'une fentre dans un bitmap (screenshot de toute la fentre)
procedure CopyWindowRectToBitmap(WindowHandle:HWND;ABitmap:TBitmap);

//Couleur d'un point d'une zone cliente
function CouleurPixel(WindowHandle:HWND;x,y:Integer):Cardinal;

procedure ScreenShotDesktop(ABitmap:TBitmap;AScreen:TScreen);

//Oprations sur les Bits (pour la rsolution de schmas)
Procedure ToggleBit(var Value: cardinal; const Bit: byte); Register;
procedure SetBit(var Value: cardinal; const Bit: byte); Register;
Procedure ClearBit(var Value: cardinal; const Bit: byte); Register;
function TestBit(const Value: cardinal; const Bit: byte): Boolean; register;
function NumBitsOn(const Value: cardinal; const Bit: byte):byte;

implementation
uses types,SysUtils,Messages,registry;

procedure VirtualMouseClickOnWindow(AWindowHandle:HWND;Boutons:TMouseButtons;APoint: TPoint);
var BoutonsSelonConfig:TMouseButtons;
    ou_ca:cardinal;
begin
  {Positionne la souris}
  ou_ca:=APoint.X+APoint.Y shl 16;

  BoutonsSelonConfig:=Boutons;
  {si on est dans une configuration de gaucher, les boutons sont inverss}
  if LeftHandledMouseConfig
  then begin
         if Boutons=BoutonGauche
         then BoutonsSelonConfig:=BoutonDroit;
         if Boutons=BoutonDroit
         then BoutonsSelonConfig:=BoutonGauche;
       end;
  {Et cliques dessus }
  case BoutonsSelonConfig of
    BoutonGauche:begin
             PostMessage(AWindowHandle, WM_LBUTTONDOWN,0,ou_ca);
             PostMessage(AWindowHandle, WM_LBUTTONUP,0,ou_ca);
           end;
    BoutonDroit:begin
             PostMessage(AWindowHandle, WM_RBUTTONDOWN,0,ou_ca);
             PostMessage(AWindowHandle, WM_RBUTTONUP,0,ou_ca);
           end;
    LesDeuxBoutons:begin
             PostMessage(AWindowHandle, WM_LBUTTONDOWN,0,ou_ca);
             PostMessage(AWindowHandle, WM_RBUTTONDOWN,0,ou_ca);
             PostMessage(AWindowHandle, WM_RBUTTONUP,0,ou_ca);
             PostMessage(AWindowHandle, WM_LBUTTONUP,0,ou_ca);
           end;
  end;
end;

procedure MouseClickOnScreen(Boutons:TMouseButtons;APoint: TPoint);
var BoutonsSelonConfig:TMouseButtons;
begin
  {Positionne la souris}
  SetCursorPos(APoint.X,APoint.Y);
  BoutonsSelonConfig:=Boutons;

  {si on est dans une configuration de gaucher, les boutons sont inverss}
  if LeftHandledMouseConfig
  then begin
         if Boutons=BoutonGauche
         then BoutonsSelonConfig:=BoutonDroit;
         if Boutons=BoutonDroit
         then BoutonsSelonConfig:=BoutonGauche;
       end;
  {Et cliques dessus }
  case BoutonsSelonConfig of
    BoutonGauche:begin
             mouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
             mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
           end;
    BoutonDroit:begin
             mouse_event(MOUSEEVENTF_RIGHTDOWN, 0, 0, 0, 0);
             mouse_event(MOUSEEVENTF_RIGHTUP, 0, 0, 0, 0);
           end;
    LesDeuxBoutons:begin
             mouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
             mouse_event(MOUSEEVENTF_RIGHTDOWN, 0, 0, 0, 0);
             mouse_event(MOUSEEVENTF_RIGHTUP, 0, 0, 0, 0);
             mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
           end;
  end;
end;

procedure ActiverFenetre(AHandle:HWND);
var ARect:TRect;
begin
  //si la fentre est cache, on la montre
  if not IsWindowVisible(AHandle)
  then ShowWindow(AHandle,SW_SHOW);

  //on rcupre le "rectangle" de la fentre, en coordonnes cran
  GetWindowRect(AHandle,ARect);
  //on clique sur la barre de titre
  MouseClickOnScreen(BoutonGauche,Point(ARect.Left+50,ARect.Top+5));
  //la fentre est active, mme si on est pas propritaire du thread
  //(chec de l'API Windows SetActiveWindow et SetFocus dans ce cas)
end;

procedure FermerApplication(AHandle:HWND);
begin
  SendMessage(AHandle,WM_CLOSE,0,0);
end;

procedure SimulateKeyDown(Key : byte);
begin
  keybd_event(Key, 0, 0, 0);
end;

procedure SimulateKeyUp(Key : byte);
begin
  keybd_event(Key, 0, KEYEVENTF_KEYUP, 0);
end;

procedure SimulateKeystroke(Key : byte; extra : DWORD);
begin
  keybd_event(Key, extra, 0, 0);
  keybd_event(Key, extra, KEYEVENTF_KEYUP, 0);
end;

procedure SendKeys(s : string);
var i : integer;
    flag : bool;
    w : word;
begin
  flag := not GetKeyState(VK_CAPITAL)=1;
  if flag then SimulateKeystroke(VK_CAPITAL, 0);
  for i :=1 to Length(s) do
  begin w := VkKeyScan(s[i]);
  if ((HiByte(w) <> $FF) and (LoByte(w) <> $FF))
  then begin
      if HiByte(w)=1
      then SimulateKeyDown(VK_SHIFT);
      SimulateKeystroke(LoByte(w), 0);
      if HiByte(w)=1
      then SimulateKeyUp(VK_SHIFT);
    end;
  end;
  if flag then SimulateKeystroke(VK_CAPITAL, 0);
end;

procedure CopyClientRectToBitmap(WindowHandle:HWND;ABitmap:TBitmap);
var WindowDeviceContext: HDC;
    WindowRect:TRect;
begin
  //La zone cliente de la fentre
  GetClientRect(WindowHandle,WindowRect);

  //Obtient un contexte de dessin sur la zone cliente de la fentre
  WindowDeviceContext:=GetDC(WindowHandle);

  try
    with ABitmap do
    begin
      with WindowRect do
      begin
        Width:=Right-Left; // Ajustement de la taille de l'image
        Height:=Bottom-top; // pour qu'elle corresponde  celle du bureau
      end;

      // Copie dans l'image bitmap
      BitBlt(Canvas.Handle, 0, 0, Width, Height,
        WindowDeviceContext, 0, 0, SRCCOPY);
    end;
  finally
    ReleaseDC(WindowHandle, WindowDeviceContext); // Libration du contexte de priphrique
  end;
end;

function CouleurPixel(WindowHandle:HWND;x,y:Integer):Cardinal;
var WindowDeviceContext: HDC;
begin
  //Obtient un contexte de dessin sur la zone cliente de la fentre
  WindowDeviceContext:=GetDC(WindowHandle);
  try
    Result:=GetPixel(WindowDeviceContext,x,y);

  finally
    ReleaseDC(WindowHandle, WindowDeviceContext); // Libration du contexte de priphrique
  end;
end;

procedure CopyWindowRectToBitmap(WindowHandle:HWND;ABitmap:TBitmap);
var WindowDeviceContext: HDC;
    WindowRect:TRect;
begin
  //Obtenir les limites de la fentre (bordure+barre de titre comprises)
  GetWindowRect(WindowHandle,WindowRect);

  //Obtient un contexte de dessin sur la fentre
  WindowDeviceContext:=GetWindowDC(WindowHandle);

  try
    with ABitmap do
    begin
      with WindowRect do
      begin
        Width:=Right-Left; // Ajustement de la taille de l'image
        Height:=Bottom-top; // pour qu'elle corresponde  celle du bureau
      end;

      // Copie dans l'image bitmap
      BitBlt(Canvas.Handle, 0, 0, Width, Height,
        WindowDeviceContext, 0, 0, SRCCOPY);
    end;
  finally
    ReleaseDC(WindowHandle, WindowDeviceContext); // Libration du contexte de priphrique
  end;
end;

procedure ScreenShotDesktop(ABitmap:TBitmap;AScreen:TScreen);
var
  desktopHandle: THandle;
  deviceContext: HDC;
begin
  desktopHandle:= GetDesktopWindow; // Rcupration du handle du bureau
  deviceContext:= GetDC(desktopHandle); // Rcupration du contexte de priphrique du bureau
  try
    Abitmap.Width:= AScreen.Width; // Ajustement de la taille de l'image
    Abitmap.Height:= AScreen.Height; // pour qu'elle corresponde  celle du bureau

    BitBlt(Abitmap.Canvas.Handle, 0, 0, Abitmap.Width, Abitmap.Height,
      deviceContext, 0, 0, SRCCOPY); // Copie du bureau dans l'image bitmap

  finally
    ReleaseDC(desktopHandle, deviceContext); // Libration du contexte de priphrique
  end;
end;

function WindowsVersion: TWinVer;
begin
  Result:=Win_XXX;
  case Win32MajorVersion of
    3: Result:=Win_NT_351;
    4: case Win32MinorVersion of
         0:  case Win32Platform of
               1: Result:=Win_95;
               2: Result:=Win_NT_40;
             end;
         10: Result:=Win_98;
         90: Result:=Win_ME;
       end;
    5: case Win32MinorVersion of
         0:  Result:=Win_2000;
         1:  Result:=Win_XP;
         2:  Result:=Win_Server_2003;
       end;
  end;
end;

function WindowsDirectory: String;
const
  dwLength: DWORD = 255;
var
  WindowsDir: PChar;
begin
  GetMem(WindowsDir, dwLength);
  GetWindowsDirectory(WindowsDir, dwLength);
  Result := String(WindowsDir);
  FreeMem(WindowsDir, dwLength);
end;

function LeftHandledMouseConfig:Boolean;
var registre:TRegistry;
begin
  registre:=TRegistry.Create;
  try
    registre.RootKey:=HKEY_CURRENT_USER;
    Registre.OpenKey('Control Panel\Mouse', False);
    Result := (Registre.ReadString('SwapMouseButtons')='1');
  finally
    registre.Free;
  end;
end;

Procedure ToggleBit(var Value: cardinal; const Bit: byte); Register;
asm
  BTC [eax],edx
end;

procedure SetBit(var Value: cardinal; const Bit: byte); Register;
asm
  BTS [eax],edx
end;

Procedure ClearBit(var Value: cardinal; const Bit: byte); Register;
asm
  BTR [eax],edx
end;

function TestBit(const Value: cardinal; const Bit: byte): Boolean; register;
asm
 BT eax,edx
 setb al
end;

function NumBitsOn(const Value: cardinal; const Bit: byte):byte;
var i,imax:byte;
begin
  Result:=0;
  imax:=bit;
  if imax>31 then imax:=31;
  for i:=0 to imax do
    if TestBit(Value,i) then Inc(Result);
end;

end.
